Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/ice.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/ice.F90	(revision 8497)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/ice.F90	(revision 8498)
@@ -332,6 +332,4 @@
 
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   afx_tot     !: ice concentration tendency (total)          [s-1]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   afx_thd     !: ice concentration tendency (thermodynamics) [s-1]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   afx_dyn     !: ice concentration tendency (dynamics)       [s-1]
 
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   sfx_bog     !: salt flux due to ice growth/melt                      [PSU/m2/s]
@@ -479,22 +477,6 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_dmi_dyn  !: Change in ice mass due to ice dynamics (kg/m2/s)
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_dms_dyn  !: Change in snow mass due to ice dynamics (kg/m2/s)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_xmtrp_ice !: X-component of ice mass transport (kg/s)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_ymtrp_ice !: Y-component of ice mass transport (kg/s)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_xmtrp_snw !: X-component of snow mass transport (kg/s)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_ymtrp_snw !: Y-component of snow mass transport (kg/s)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_xatrp    !: X-component of area transport (m2/s)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_yatrp    !: Y-component of area transport (m2/s)
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_fc_bo    !: Bottom conduction flux (W/m2)
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_fc_su    !: Surface conduction flux (W/m2)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_utau_oi  !: X-direction ocean-ice stress
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_vtau_oi  !: Y-direction ocean-ice stress  
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_dssh_dx  !: X-direction sea-surface tilt term (N/m2)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_dssh_dy  !: X-direction sea-surface tilt term (N/m2)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_corstrx  !: X-direction coriolis stress (N/m2)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_corstry  !: Y-direction coriolis stress (N/m2)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_intstrx  !: X-direction internal stress (N/m2)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_intstry  !: Y-direction internal stress (N/m2)
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_sig1     !: Average normal stress in sea ice   
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_sig2     !: Maximum shear stress in sea ice
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::   diag_shear    !: Maximum shear of sea-ice velocity field
 
@@ -534,5 +516,5 @@
          &      wfx_bog(jpi,jpj) , wfx_dyn(jpi,jpj) , wfx_bom(jpi,jpj) , wfx_sum(jpi,jpj) ,     &
          &      wfx_res(jpi,jpj) , wfx_sni(jpi,jpj) , wfx_opw(jpi,jpj) , wfx_spr(jpi,jpj) ,     &
-         &      afx_tot(jpi,jpj) , afx_thd(jpi,jpj),  afx_dyn(jpi,jpj) , rn_amax_2d(jpi,jpj),   &
+         &      afx_tot(jpi,jpj) , rn_amax_2d(jpi,jpj),                                         &
          &      fhtur  (jpi,jpj) , qlead  (jpi,jpj) ,                                           &
          &      sfx_res(jpi,jpj) , sfx_bri(jpi,jpj) , sfx_dyn(jpi,jpj) , sfx_sub(jpi,jpj) , sfx_lam(jpi,jpj) ,  &
@@ -616,13 +598,5 @@
       ALLOCATE( t_si (jpi,jpj,jpl)    , tm_si(jpi,jpj)        ,    & 
                 diag_dmi_dyn(jpi,jpj) , diag_dms_dyn(jpi,jpj) ,    &
-                diag_xmtrp_ice(jpi,jpj), diag_ymtrp_ice(jpi,jpj),  &
-                diag_xmtrp_snw(jpi,jpj), diag_ymtrp_snw(jpi,jpj),  &
-                diag_xatrp(jpi,jpj)    , diag_yatrp(jpi,jpj)    ,  &
                 diag_fc_bo(jpi,jpj)   , diag_fc_su(jpi,jpj)   ,    &
-                diag_utau_oi(jpi,jpj) , diag_vtau_oi(jpi,jpj) ,    &
-                diag_dssh_dx(jpi,jpj) , diag_dssh_dy(jpi,jpj) ,    &
-                diag_corstrx(jpi,jpj) , diag_corstry(jpi,jpj) ,    &
-                diag_intstrx(jpi,jpj) , diag_intstry(jpi,jpj) ,    &
-                diag_sig1(jpi,jpj)    , diag_sig2(jpi,jpj)    ,    &
                 diag_shear(jpi,jpj)   , STAT = ierr(ii) )
 
Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icealb.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icealb.F90	(revision 8497)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icealb.F90	(revision 8498)
@@ -27,11 +27,10 @@
    REAL(wp), PUBLIC, PARAMETER ::   rn_alb_oce = 0.066   !: ocean or lead albedo (Pegau and Paulson, Ann. Glac. 2001)
 
-!!gm real variable name starting with a "c" NOT DOCTOR !!!!
    INTEGER  ::   albd_init = 0       ! control flag for initialization  
-   REAL(wp) , PARAMETER ::   c1        = 0.05    ! snow thickness (only for nn_ice_alb=0)
-   REAL(wp) , PARAMETER ::   c2        = 0.10    !  "        "
-   REAL(wp) , PARAMETER ::   rcloud    = 0.06    ! cloud effect on albedo (only-for nn_ice_alb=0)
-   REAL(wp) , PARAMETER ::   r1_c1 = 1. / c1
-   REAL(wp) , PARAMETER ::   r1_c2 = 1. / c2
+   REAL(wp) , PARAMETER ::   rc1    = 0.05    ! snow thickness (only for nn_ice_alb=0)
+   REAL(wp) , PARAMETER ::   rc2    = 0.10    !  "        "
+   REAL(wp) , PARAMETER ::   rcloud = 0.06    ! cloud effect on albedo (only-for nn_ice_alb=0)
+   REAL(wp) , PARAMETER ::   r1_c1 = 1. / rc1
+   REAL(wp) , PARAMETER ::   r1_c2 = 1. / rc2
  
    !                             !!* namelist namsbc_alb *
@@ -114,8 +113,7 @@
       IF ( .NOT. ld_pnd ) THEN   !--- No melt ponds OR radiatively inactive melt ponds
          ! Bare ice albedo is prescribed, with implicit assumption on pond fraction and depth
-         WHERE     ( ph_snw == 0._wp .AND. pt_ice >= rt0_ice )   ;   zalb(:,:,:) = rn_alb_imlt
-                                                       ! !!! MV I think we could replace rt0_ice by rt0 and get rid of rt0
-         ELSE WHERE                                              ;   zalb(:,:,:) = rn_alb_idry
-         END  WHERE
+         WHERE     ( ph_snw == 0._wp .AND. pt_ice >= rt0 )   ;   zalb(:,:,:) = rn_alb_imlt
+         ELSEWHERE                                           ;   zalb(:,:,:) = rn_alb_idry
+         END WHERE
       ENDIF
 
@@ -127,10 +125,10 @@
          !
          !                       ! Thickness-dependent bare ice albedo
-         WHERE     ( 1.5  < ph_ice                     )  ;  zalb_it = zalb
-         ELSE WHERE( 1.0  < ph_ice .AND. ph_ice <= 1.5 )  ;  zalb_it = 0.472  + 2.0 * ( zalb - 0.472 ) * ( ph_ice - 1.0 )
-         ELSE WHERE( 0.05 < ph_ice .AND. ph_ice <= 1.0 )  ;  zalb_it = 0.2467 + 0.7049 * ph_ice              &
-            &                                                                 - 0.8608 * ph_ice * ph_ice     &
-            &                                                                 + 0.3812 * ph_ice * ph_ice * ph_ice
-         ELSE WHERE                                       ;  zalb_it = 0.1    + 3.6    * ph_ice
+         WHERE    ( 1.5  < ph_ice                     )   ;   zalb_it = zalb
+         ELSEWHERE( 1.0  < ph_ice .AND. ph_ice <= 1.5 )   ;   zalb_it = 0.472  + 2.0 * ( zalb - 0.472 ) * ( ph_ice - 1.0 )
+         ELSEWHERE( 0.05 < ph_ice .AND. ph_ice <= 1.0 )   ;   zalb_it = 0.2467 + 0.7049 * ph_ice              &
+            &                                                                  - 0.8608 * ph_ice * ph_ice     &
+            &                                                                  + 0.3812 * ph_ice * ph_ice * ph_ice
+         ELSEWHERE                                        ;   zalb_it = 0.1    + 3.6    * ph_ice
          END WHERE
          !
@@ -139,5 +137,5 @@
             zalb_pnd  = rn_alb_dpnd - ( rn_alb_dpnd - zalb_it ) * EXP( - ph_pnd * z1_href_pnd ) 
             !                          ! Snow-free ice albedo is a function of pond fraction
-            WHERE ( ph_snw == 0._wp .AND. pt_ice >= rt0_ice )   
+            WHERE ( ph_snw == 0._wp .AND. pt_ice >= rt0 )   
                zalb_it = zalb_it * ( 1. - pafrac_pnd  ) + zalb_pnd * pafrac_pnd 
             END WHERE
@@ -150,6 +148,6 @@
                DO ji = 1, jpi
                   !                    ! Freezing snow
-                  ! no effect of underlying ice layer IF snow thickness > c1. Albedo does not depend on snow thick if > c2
-                  zswitch = 1._wp - MAX( 0._wp , SIGN( 1._wp , - ( ph_snw(ji,jj,jl) - c1 ) ) )
+                  ! no effect of underlying ice layer IF snow thickness > c1. Albedo does not depend on snow thick if > rc2
+                  zswitch = 1._wp - MAX( 0._wp , SIGN( 1._wp , - ( ph_snw(ji,jj,jl) - rc1 ) ) )
                   zalb_sf = ( 1._wp - zswitch ) * (  zalb_it(ji,jj,jl)  &
                      &                                   + ph_snw(ji,jj,jl) * ( rn_alb_sdry - zalb_it(ji,jj,jl) ) * r1_c1  )   &
@@ -157,6 +155,6 @@
                      !
                   !                    ! Melting snow
-                  ! no effect of underlying ice layer. Albedo does not depend on snow thick IF > c2
-                  zswitch = MAX( 0._wp , SIGN( 1._wp , ph_snw(ji,jj,jl) - c2 ) )
+                  ! no effect of underlying ice layer. Albedo does not depend on snow thick IF > rc2
+                  zswitch = MAX( 0._wp , SIGN( 1._wp , ph_snw(ji,jj,jl) - rc2 ) )
                   zalb_sm = ( 1._wp - zswitch ) * ( rn_alb_imlt + ph_snw(ji,jj,jl) * ( rn_alb_smlt - rn_alb_imlt ) * r1_c2 )   &
                      &      +         zswitch   *   rn_alb_smlt 
@@ -211,5 +209,5 @@
             !
             !                    ! Snow-free ice albedo is weighted mean of ponded ice and bare ice contributions
-            WHERE ( ph_snw == 0._wp .AND. pt_ice >= rt0_ice )
+            WHERE ( ph_snw == 0._wp .AND. pt_ice >= rt0 )
                zalb_it = zalb_it * ( 1. - pafrac_pnd  ) + zalb_pnd * pafrac_pnd
             END WHERE
@@ -256,11 +254,11 @@
          !                       !--- Effective pond fraction (for now, we prevent melt ponds and snow at the same time)
          zafrac_pnd = 0._wp
-         IF ( ld_pnd ) THEN  
-            WHERE( ph_snw == 0._wp ) ;  zafrac_pnd = pafrac_pnd ;  END WHERE  ! Snow fully "shades" melt ponds
+         IF ( ld_pnd ) THEN
+            WHERE( ph_snw == 0._wp )   zafrac_pnd = pafrac_pnd   ! Snow fully "shades" melt ponds
          ENDIF         
          !
          !                       !--- Specific snow fraction (for now, prescribed)
-         WHERE     ( ph_snw > 0._wp     ) ;  zafrac_snw = 1.
-         ELSE WHERE                       ;  zafrac_snw = 0.
+         WHERE( ph_snw > 0._wp )   ;   zafrac_snw = 1.
+         ELSEWHERE                 ;   zafrac_snw = 0.
          END WHERE
          !
@@ -273,8 +271,8 @@
          z1_c1 = 1. / ( LOG(1.5) - LOG(0.05) ) 
          z1_c2 = 1. / 0.05
-         WHERE     ( 1.5  < ph_ice                     )  ;  zalb_ice = zalb
-         ELSE WHERE( 0.05 < ph_ice .AND. ph_ice <= 1.5 )  ;  zalb_ice = zalb     + ( 0.18 - zalb     ) * z1_c1 *  &
+         WHERE    ( 1.5  < ph_ice                     )   ;   zalb_ice = zalb
+         ELSEWHERE( 0.05 < ph_ice .AND. ph_ice <= 1.5 )   ;   zalb_ice = zalb       + ( 0.18 - zalb       ) * z1_c1 *  &
             &                                                                       ( LOG(1.5) - LOG(ph_ice) )
-         ELSE WHERE                                       ;  zalb_ice = rn_alb_oce + ( 0.18 - rn_alb_oce ) * z1_c2 * ph_ice
+         ELSEWHERE                                        ;   zalb_ice = rn_alb_oce + ( 0.18 - rn_alb_oce ) * z1_c2 * ph_ice
          END WHERE
          !
@@ -282,6 +280,6 @@
          z1_c2 = 1. / 0.03
          !
-         WHERE( pt_ice < rt0_snow ) ; zalb_snw = rn_alb_sdry - ( rn_alb_sdry - zalb_ice ) * EXP( - ph_snw * z1_c1 );
-         ELSE WHERE                 ; zalb_snw = rn_alb_smlt - ( rn_alb_smlt - zalb_ice ) * EXP( - ph_snw * z1_c2 );
+         WHERE( pt_ice < rt0_snow )   ;   zalb_snw = rn_alb_sdry - ( rn_alb_sdry - zalb_ice ) * EXP( - ph_snw * z1_c1 )
+         ELSEWHERE                    ;   zalb_snw = rn_alb_smlt - ( rn_alb_smlt - zalb_ice ) * EXP( - ph_snw * z1_c2 )
          END WHERE
          !
Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icecor.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icecor.F90	(revision 8497)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icecor.F90	(revision 8498)
@@ -26,4 +26,5 @@
    USE lib_mpp        ! MPP library
    USE timing         ! Timing
+   USE iom            !
 
    IMPLICIT NONE
@@ -53,4 +54,5 @@
       INTEGER  ::   ji, jj, jk, jl   ! dummy loop indices
       REAL(wp) ::   zsal, zvi_b, zsmv_b, zei_b, zfs_b, zfw_b, zft_b, zzc
+      REAL(wp), DIMENSION(jpi,jpj) ::   zafx   ! concentration trends diag
       !!----------------------------------------------------------------------
       IF( nn_timing == 1 )   CALL timing_start('icecor')
@@ -65,69 +67,32 @@
       !
       !
-      !                             !-----------------------------------------------------
-      IF( kn == 2 ) THEN            !  thickness of the smallest category above himin    !
+      IF( kn == 2 ) THEN
          !                          !-----------------------------------------------------
-         !
-         DO jj = 1, jpj 
-            DO ji = 1, jpi
-!!gm replace this
-               rswitch = MAX( 0._wp , SIGN( 1._wp, a_i(ji,jj,1) - epsi20 ) )   !0 if no ice and 1 if yes
-               ht_i(ji,jj,1) = v_i (ji,jj,1) / MAX( a_i(ji,jj,1) , epsi20 ) * rswitch
-!!gm by more readable coding (not slower coding since already a IF in the loop):
-!               IF( a_i(ji,jj,1) >= epsi20 )   ht_i(ji,jj,1) = v_i (ji,jj,1) / a_i(ji,jj,1)
-!!gm
-               IF( v_i(ji,jj,1) > 0._wp .AND. ht_i(ji,jj,1) < rn_himin ) THEN
-                  a_i (ji,jj,1) = a_i (ji,jj,1) * ht_i(ji,jj,1) / rn_himin
-               ENDIF
-            END DO
-         END DO
+         !                          !  thickness of the smallest category above himin    !
+         !                          !-----------------------------------------------------
+         WHERE( a_i(:,:,1) >= epsi20 )   ;   ht_i(:,:,1) = v_i (:,:,1) / a_i(:,:,1)
+         ELSEWHERE                       ;   ht_i(:,:,1) = 0._wp
+         END WHERE
+         WHERE( ht_i(:,:,1) < rn_himin )     a_i (:,:,1) = a_i (:,:,1) * ht_i(:,:,1) / rn_himin
          !
       ENDIF
-
       !                             !-----------------------------------------------------
-      at_i(:,:) = a_i(:,:,1)        !  ice concentration should not exceed amax          !
-      DO jl = 2, jpl                !-----------------------------------------------------
-         at_i(:,:) = a_i(:,:,jl) + at_i(:,:)
+      !                             !  ice concentration should not exceed amax          !
+      !                             !-----------------------------------------------------
+      at_i(:,:) = SUM( a_i(:,:,:), dim=3 )
+      DO jl  = 1, jpl
+         WHERE( at_i(:,:) > rn_amax_2d(:,:) )   a_i(:,:,jl) = a_i(:,:,jl) * rn_amax_2d(:,:) / at_i(:,:)
       END DO
-      !
-!!gm   Question   it seams to me that we have the following equality (dropping the "(ji,jj)":
-!      ( 1. - ( 1. - rn_amax_2d / at_i ) ) =  ( 1. - ( at_i - rn_amax_2d ) / at_i )
-!                                          =  ( at_i - ( at_i - rn_amax_2d ) ) / at_i
-!                                          =  ( + rn_amax_2d  ) / at_i
-!                                          =  rn_amax_2d / at_i
-!     No ?  if yes see "!!gm   better" juste below 
-!gm
-      DO jl  = 1, jpl
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               IF( at_i(ji,jj) > rn_amax_2d(ji,jj) .AND. a_i(ji,jj,jl) > 0._wp ) THEN
-                  a_i(ji,jj,jl) = a_i(ji,jj,jl) * ( 1._wp - ( 1._wp - rn_amax_2d(ji,jj) / at_i(ji,jj) ) )
-!!gm   better:    a_i(ji,jj,jl) = a_i(ji,jj,jl) * rn_amax_2d(ji,jj) / at_i(ji,jj)           
-               ENDIF
-            END DO
-         END DO
-      END DO
-!!gm  Other question:  why testing a_i(ji,jj,jl) > 0._wp ?   a_i is >=0, a multiplication by 0 does not change the results....
-!!gm  so at the end, the loop can be recoded without IF as:
-!      WHERE( at_i(:,:) > rn_amax_2d(:,:) )
-!         DO jl  = 1, jpl
-!            a_i(:,:,jl) = a_i(:,:,jl) * MAX( rn_amax_2d(:,:), at_i(:,:) ) / at_i(:,:)
-!         END DO
-!      END WHERE
-!!gm  No?
     
       !                             !-----------------------------------------------------
-      IF (  nn_icesal == 2  ) THEN  !  Ice salinity bounds                               !
+      IF (  nn_icesal == 2  ) THEN  !  salinity stays in bounds [Simin,Simax]            !
       !                             !-----------------------------------------------------
          zzc = rhoic * r1_rdtice
-         DO jl = 1, jpl                  ! salinity stays in bounds [Simin,Simax]
+         DO jl = 1, jpl
             DO jj = 1, jpj 
                DO ji = 1, jpi
-                  IF( v_i(ji,jj,jl) > 0._wp ) THEN   ! clem: useless IF ???
-                     zsal = smv_i(ji,jj,jl)
-                     smv_i(ji,jj,jl) = MIN(  MAX( rn_simin*v_i(ji,jj,jl) , smv_i(ji,jj,jl) ) , rn_simax*v_i(ji,jj,jl)  )
-                     ! associated salt flux
-                     sfx_res(ji,jj) = sfx_res(ji,jj) - ( smv_i(ji,jj,jl) - zsal ) * zzc
-                  ENDIF
+                  zsal = smv_i(ji,jj,jl)
+                  smv_i(ji,jj,jl) = MIN(  MAX( rn_simin*v_i(ji,jj,jl) , smv_i(ji,jj,jl) ) , rn_simax*v_i(ji,jj,jl)  )
+                  sfx_res(ji,jj) = sfx_res(ji,jj) - ( smv_i(ji,jj,jl) - zsal ) * zzc   ! associated salt flux
                END DO
             END DO
@@ -157,8 +122,4 @@
          END DO
          CALL lbc_lnk_multi( u_ice, 'U', -1., v_ice, 'V', -1. )            ! lateral boundary conditions
-         !
-!!gm  I think masking here is unnecessary, u_ice already masked and we only introduce zeros in the field
-         u_ice(:,:) = u_ice(:,:) * umask(:,:,1)                            ! mask velocities
-         v_ice(:,:) = v_ice(:,:) * vmask(:,:,1)
       ENDIF
 
@@ -172,7 +133,4 @@
       !                             !-----------------------------------------------------
       CASE( 1 )                        !--- dyn trend diagnostics
-         DO jl  = 1, jpl
-            afx_dyn(:,:) = afx_dyn(:,:) + ( a_i(:,:,jl) - a_i_b(:,:,jl) ) * r1_rdtice
-         END DO
          !
 !!gm   here I think the number of ice cat is too small to use a SUM instruction...
@@ -188,12 +146,12 @@
             END DO
          END DO
+         !                       ! concentration tendency (dynamics)
+         zafx   (:,:) = SUM( a_i(:,:,:) - a_i_b(:,:,:), dim=3 ) * r1_rdtice 
+         afx_tot(:,:) = zafx(:,:)
+         IF( iom_use('afxdyn') )   CALL iom_put( 'afxdyn' , zafx(:,:) )
          !
       CASE( 2 )                        !--- thermo trend diagnostics & ice aging
          !
-         DO jl  = 1, jpl
-            oa_i(:,:,jl) = oa_i(:,:,jl) +   a_i(:,:,jl)                   * rdt_ice       ! ice natural aging incrementation
-            afx_thd(:,:) = afx_thd(:,:) + ( a_i(:,:,jl) - a_i_b(:,:,jl) ) * r1_rdtice     ! thermo tendancy
-         END DO
-         afx_tot(:,:) = afx_thd(:,:) + afx_dyn(:,:)
+         oa_i(:,:,:) = oa_i(:,:,:) + a_i(:,:,:) * rdt_ice   ! ice natural aging incrementation
          !
 !!gm   here I think the number of ice cat is too small to use a SUM instruction...
@@ -209,4 +167,9 @@
             END DO
          END DO
+         !                       ! concentration tendency (total + thermo)
+         zafx   (:,:) = SUM( a_i(:,:,:) - a_i_b(:,:,:), dim=3 ) * r1_rdtice
+         afx_tot(:,:) = afx_tot(:,:) + zafx(:,:)
+         IF( iom_use('afxthd') )   CALL iom_put( 'afxthd' , zafx(:,:) )
+         IF( iom_use('afxtot') )   CALL iom_put( 'afxtot' , afx_tot(:,:) )
          !
       END SELECT
Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icectl.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icectl.F90	(revision 8497)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icectl.F90	(revision 8498)
@@ -71,9 +71,5 @@
       REAL(wp), PARAMETER             :: zconv = 1.e-9 ! convert W to GW and kg to Mt
       !!----------------------------------------------------------------------
-
-!!gm  Note that glo_sum for a 2D or 3D array use a multiplication by tmask_i(ji,jj)
-!!    so below  the  * tmask(:,:,1) is useless   ===>> I have removed them
-!!    I also move the conversion factor from then glo_sum argument (become a single multiplication
- 
+      !
       IF( icount == 0 ) THEN
          !                          ! salt flux
@@ -271,6 +267,4 @@
                !WRITE(numout,*) ' sea-ice stress utau_ice  : ', utau_ice(ji,jj) 
                !WRITE(numout,*) ' sea-ice stress vtau_ice  : ', vtau_ice(ji,jj)
-               !WRITE(numout,*) ' oceanic speed u          : ', u_oce(ji,jj)
-               !WRITE(numout,*) ' oceanic speed v          : ', v_oce(ji,jj)
                !WRITE(numout,*) ' sst                      : ', sst_m(ji,jj)
                !WRITE(numout,*) ' sss                      : ', sss_m(ji,jj)
@@ -556,6 +550,4 @@
                WRITE(numout,*) ' utau       : ', utau    (ji,jj) 
                WRITE(numout,*) ' vtau       : ', vtau    (ji,jj)
-               WRITE(numout,*) ' oc. vel. u : ', u_oce   (ji,jj)
-               WRITE(numout,*) ' oc. vel. v : ', v_oce   (ji,jj)
             ENDIF
             
@@ -669,5 +661,4 @@
       CALL prt_ctl(tab2d_1=utau       , clinfo1= ' utau      : ', tab2d_2=vtau       , clinfo2= ' vtau      : ')
       CALL prt_ctl(tab2d_1=utau_ice   , clinfo1= ' utau_ice  : ', tab2d_2=vtau_ice   , clinfo2= ' vtau_ice  : ')
-      CALL prt_ctl(tab2d_1=u_oce      , clinfo1= ' u_oce     : ', tab2d_2=v_oce      , clinfo2= ' v_oce     : ')
       
    END SUBROUTINE ice_prt3D
Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceforcing.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceforcing.F90	(revision 8497)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceforcing.F90	(revision 8498)
@@ -65,5 +65,5 @@
       IF( kt == nit000 .AND. lwp ) THEN
          WRITE(numout,*)
-         WRITE(numout,*)'ice_forcing_tau'
+         WRITE(numout,*)'ice_forcing_tau : Surface boundary condition for sea ice (momentum)'
          WRITE(numout,*)'~~~~~~~~~~~~~~~'
       ENDIF
@@ -124,5 +124,5 @@
       IF( kt == nit000 .AND. lwp ) THEN
          WRITE(numout,*)
-         WRITE(numout,*)'ice_forcing_flx'
+         WRITE(numout,*)'ice_forcing_flx : Surface boundary condition for sea ice (flux)'
          WRITE(numout,*)'~~~~~~~~~~~~~~~'
       ENDIF
@@ -132,13 +132,6 @@
 
       ! albedo depends on cloud fraction because of non-linear spectral effects
-      DO jl = 1, jpl
-         DO jj = 2, jpjm1
-            DO ji = 2, jpim1
 !!gm cldf_ice is a real, DOCTOR naming rule: start with cd means CHARACTER passed in argument !
-               alb_ice(ji,jj,jl) = ( 1. - cldf_ice ) * zalb_cs(ji,jj,jl) + cldf_ice * zalb_os(ji,jj,jl)
-            END DO
-         END DO
-      END DO
-      CALL lbc_lnk( alb_ice, 'T', 1. )
+      alb_ice(:,:,:) = ( 1. - cldf_ice ) * zalb_cs(:,:,:) + cldf_ice * zalb_os(:,:,:)
       
       SELECT CASE( ksbc )      !==  fluxes over sea ice  ==!
@@ -198,52 +191,52 @@
       INTEGER  ::   jl      ! dummy loop index
       !
-      REAL(wp), DIMENSION(jpi,jpj) :: zalb_m    ! Mean albedo over all categories
-      REAL(wp), DIMENSION(jpi,jpj) :: ztem_m    ! Mean temperature over all categories
-      !
-      REAL(wp), DIMENSION(jpi,jpj) :: z_qsr_m   ! Mean solar heat flux over all categories
-      REAL(wp), DIMENSION(jpi,jpj) :: z_qns_m   ! Mean non solar heat flux over all categories
-      REAL(wp), DIMENSION(jpi,jpj) :: z_evap_m  ! Mean sublimation over all categories
-      REAL(wp), DIMENSION(jpi,jpj) :: z_dqn_m   ! Mean d(qns)/dT over all categories
-      REAL(wp), DIMENSION(jpi,jpj) :: z_devap_m ! Mean d(evap)/dT over all categories
+      REAL(wp), DIMENSION(jpi,jpj) ::   z1_at_i   ! inverse of concentration
+      !
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::   z_qsr_m   ! Mean solar heat flux over all categories
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::   z_qns_m   ! Mean non solar heat flux over all categories
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::   z_evap_m  ! Mean sublimation over all categories
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::   z_dqn_m   ! Mean d(qns)/dT over all categories
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::   z_devap_m ! Mean d(evap)/dT over all categories
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::   zalb_m    ! Mean albedo over all categories
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::   ztem_m    ! Mean temperature over all categories
       !!----------------------------------------------------------------------
       !
       IF( nn_timing == 1 )  CALL timing_start('ice_flx_dist')
       !
+      WHERE ( at_i (:,:) > 0._wp )   ; z1_at_i(:,:) = 1._wp / at_i (:,:)
+      ELSEWHERE                      ; z1_at_i(:,:) = 0._wp
+      END WHERE
+      
       SELECT CASE( k_limflx )       !==  averaged on all ice categories  ==!
       !
       CASE( 0 , 1 )
-         z_qns_m  (:,:) = fice_ice_ave( pqns_ice  (:,:,:) )
-         z_qsr_m  (:,:) = fice_ice_ave( pqsr_ice  (:,:,:) )
-         z_dqn_m  (:,:) = fice_ice_ave( pdqn_ice  (:,:,:) )
-         z_evap_m (:,:) = fice_ice_ave( pevap_ice (:,:,:) )
-         z_devap_m(:,:) = fice_ice_ave( pdevap_ice(:,:,:) )
-!!gm faster coding
-!    REAL(wp), DIMENSION(jpi,jpj) ::   z1_at_i   ! 
-! ...
-!      WHERE ( at_i (:,:) > 0._wp )   ; z1_at_i(:,:) = 1._wp / at_i (:,:)
-!      ELSEWHERE                      ; z1_at_i(:,:) = 0._wp
-!      END WHERE
-!      z_qns_m  (:,:) = SUM( a_i(:,:,:) * pqns_ice  (:,:,:) , dim=3 ) * z1_at_i(:,:)
-!      z_qsr_m  (:,:) = SUM( a_i(:,:,:) * pqsr_ice  (:,:,:) , dim=3 ) * z1_at_i(:,:)
-!      z_dqn_m  (:,:) = SUM( a_i(:,:,:) * pdqn_ice  (:,:,:) , dim=3 ) * z1_at_i(:,:)
-!      z_evap_m (:,:) = SUM( a_i(:,:,:) * pevap_ice (:,:,:) , dim=3 ) * z1_at_i(:,:)
-!      z_devap_m(:,:) = SUM( a_i(:,:,:) * pdevap_ice(:,:,:) , dim=3 ) * z1_at_i(:,:)
-!! and remove the 2 functions: fice_ice_ave and fice_cell_ave
-!!gm
+         !
+         ALLOCATE( z_qns_m(jpi,jpj), z_qsr_m(jpi,jpj), z_dqn_m(jpi,jpj), z_evap_m(jpi,jpj), z_devap_m(jpi,jpj) )  
+         !
+         z_qns_m  (:,:) = SUM( a_i(:,:,:) * pqns_ice  (:,:,:) , dim=3 ) * z1_at_i(:,:)
+         z_qsr_m  (:,:) = SUM( a_i(:,:,:) * pqsr_ice  (:,:,:) , dim=3 ) * z1_at_i(:,:)
+         z_dqn_m  (:,:) = SUM( a_i(:,:,:) * pdqn_ice  (:,:,:) , dim=3 ) * z1_at_i(:,:)
+         z_evap_m (:,:) = SUM( a_i(:,:,:) * pevap_ice (:,:,:) , dim=3 ) * z1_at_i(:,:)
+         z_devap_m(:,:) = SUM( a_i(:,:,:) * pdevap_ice(:,:,:) , dim=3 ) * z1_at_i(:,:)
          DO jl = 1, jpl
-            pdqn_ice  (:,:,jl) = z_dqn_m  (:,:)
-            pdevap_ice(:,:,jl) = z_devap_m(:,:)
             pqns_ice  (:,:,jl) = z_qns_m (:,:)
             pqsr_ice  (:,:,jl) = z_qsr_m (:,:)
+            pdqn_ice  (:,:,jl) = z_dqn_m  (:,:)
             pevap_ice (:,:,jl) = z_evap_m(:,:)
+            pdevap_ice(:,:,jl) = z_devap_m(:,:)
          END DO
          !
+         DEALLOCATE( z_qns_m, z_qsr_m, z_dqn_m, z_evap_m, z_devap_m )  
+         !
       END SELECT
       !
       SELECT CASE( k_limflx )       !==  redistribution on all ice categories  ==!
+      !
       CASE( 1 , 2 )
          !
-         zalb_m(:,:) = fice_ice_ave( palb_ice(:,:,:) )
-         ztem_m(:,:) = fice_ice_ave( ptn_ice (:,:,:) )
+         ALLOCATE( zalb_m(jpi,jpj), ztem_m(jpi,jpj) )  
+         !
+         zalb_m(:,:) = SUM( a_i(:,:,:) * palb_ice(:,:,:) , dim=3 ) * z1_at_i(:,:)
+         ztem_m(:,:) = SUM( a_i(:,:,:) * ptn_ice (:,:,:) , dim=3 ) * z1_at_i(:,:)
          DO jl = 1, jpl
             pqns_ice (:,:,jl) = pqns_ice (:,:,jl) + pdqn_ice  (:,:,jl) * ( ptn_ice(:,:,jl) - ztem_m(:,:) )
@@ -252,4 +245,6 @@
          END DO
          !
+         DEALLOCATE( zalb_m, ztem_m )  
+         !
       END SELECT
       !
@@ -257,34 +252,4 @@
       !
    END SUBROUTINE ice_flx_dist
-
-!!gm TO BE REMOVED ====>>>>>
-   FUNCTION fice_cell_ave ( ptab )
-      !!--------------------------------------------------------------------------
-      !! * Compute average over categories, for grid cell (ice covered and free ocean)
-      !!--------------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj,jpl), INTENT(in) :: ptab
-      REAL(wp), DIMENSION(jpi,jpj)                 :: fice_cell_ave
-      INTEGER :: jl
-      !!--------------------------------------------------------------------------
-      fice_cell_ave(:,:) = a_i(:,:,1) * ptab (:,:,1)
-      DO jl = 2, jpl
-         fice_cell_ave(:,:) = fice_cell_ave(:,:) + a_i(:,:,jl) * ptab (:,:,jl)
-      END DO
-   END FUNCTION fice_cell_ave
-
-
-   FUNCTION fice_ice_ave ( ptab )
-      !!--------------------------------------------------------------------------
-      !! * Compute average over categories, for ice covered part of grid cell
-      !!--------------------------------------------------------------------------
-      REAL(wp), DIMENSION(jpi,jpj,jpl), INTENT(in) ::   ptab   !
-      REAL(wp), DIMENSION(jpi,jpj)                 :: fice_ice_ave
-      !!--------------------------------------------------------------------------
-      WHERE ( at_i (:,:) > 0.0_wp ) ; fice_ice_ave (:,:) = fice_cell_ave( ptab (:,:,:) ) / at_i (:,:)
-      ELSEWHERE                     ; fice_ice_ave (:,:) = 0.0_wp
-      END WHERE
-   END FUNCTION fice_ice_ave
-
-!!gm <<<<<<====  end of TO BE REMOVED 
 
 #else
